/**
 * Reset some basic elements

body, h1, h2, h3, h4, h5, h6,
p, blockquote, pre, hr,
dl, dd, ol, ul, figure {
    margin: 0;
    padding: 0;
}
 */


/**
 * Basic styling
 */
body {
    margin: 0;
    padding: 0;
    font-family: $base-font-family;
    @media screen {
        font-size: $base-font-size;
    }
    @media print {
        font-size: $print-font-size;
        /* line-height: $print-line-height;*/
    }
    line-height: $base-line-height;
    /* font-weight: 300; */
    color: $text-color;
    background-color: $background-color;
}
h1, h2, h3, h4, h5, h6 {
    margin: 0.75em 0 0.5em 0;
    font-weight: 400;
}

article {
    h1, h2, .heavy-heading {
        font-weight: bold;
        border-bottom: 2px solid;
    }
    h3, .medium-heading {
        border-bottom: 1px solid lighten($grey-color, 30%);
    }
    h4, .light-heading {
        border-bottom: 1px dotted lighten($grey-color,40%);
    }
}
.tight {
    letter-spacing: -1px;
}

p, blockquote, pre,
ul, ol, dl, figure {
    margin: 0.5em 0;
}
ul, ol {
    padding: 0 2em;
}
.highlight, alert_wrapper {
    overflow: initial;
}
.highlight pre, .alert_wrapper .alert_box {
    margin-left: 2em;
    margin-right: 2em;
}
@media (max-width: $width-vertical) {
    .highlight pre, .alert_wrapper .box {
        margin-left: 0;
        margin-right: 0;
    }
}

/*
h1, h2, h3, h4, h5, h6,
p, blockquote, pre,
ul, ol, dl, figure {
    margin-bottom: $spacing-unit / 2;
}
p {
  margin-top: $spacing-unit / 2;
}
*/


img {
    max-width: 100%;
    /* vertical-align: middle; */
}

figure > img {
    display: block;
}

figcaption {
    font-size: $small-font-size;
}
li {
    > ul,
    > ol,
    > dl {
         margin-top: 0;
         margin-bottom: 0;
    }
}
.alpha > li,
.roman > li,
.alpha_marker > li,
.letter_marker > li,
.roman_marker > li {
    margin: 0.5em 0;
}

form.like_link {
    display: inline;
    border: none;
    background: none;
    padding: 0;
    margin: 0;
    input {
        font-family: $base-font-family;
        display: none;
    }
    input[type="submit"] {
        display: inline;
        background: none;
        border: none;
        cursor: pointer;
        padding: 0;
        margin: 0;
        font-family: $base-font-family;
        @media screen {
            font-size: $base-font-size;
        }
        @media print {
            font-size: $print-font-size;
            /* line-height: $print-line-height;*/
        }
        line-height: $base-line-height;
        /* font-weight: 300; */
    }
}

a, #staff-table th a, form.like_link input {
    color: $brand-color;
    text-decoration: none;

    &:visited {
        color: darken($brand-color, 15%);
    }

    &:hover {
        /* color: $text-color; */
        text-decoration: underline;
    }
}


blockquote {
    color: $grey-color;
    border-left: 4px solid $grey-color-light;
    padding-left: $spacing-unit / 2;
    font-style: italic;

    > :last-child {
        margin-bottom: 0;
    }
}


pre,
code {
    border: 1px solid $grey-color-light;
    border-radius: 3px;
    background-color: #f3f3f3;
}

code {
    padding: 1px 5px;
}

pre {
    padding: 2px 6px;
    @media screen {
        overflow-x: scroll;
        /* width: 90%; */
        margin: auto;
    }
    @media print {
        overflow-x: wrap;
    }

    > code {
        border: 0;
        padding-right: 0;
        padding-left: 0;
    }
}

@media (max-width: $width-vertical) {
    pre {
        width: initial;
    }
}


%clearfix {
    &:after {
        content: "";
        display: table;
        clear: both;
    }
}

.green {
    color: $green-color;
}

.site_tag,
.purple_tag,
.orange_tag,
.green_tag,
.red_tag,
.blue_tag,
.tag {
    border-radius: 3px;
    border: 1px solid;
    padding: 1px 5px;
    font-size: smaller;
    font-weight: bold;
}

.site_tag {
    border-color: $site-color;
    color: $site-color;
    background: $site-color-light;
}
a.site_tag:visited {
    color: $site-color;
}
a.site_tag:hover {
    color: white;
    background: $site-color;
    text-decoration: none;
}

.purple_tag,
.lab_tag {
    border-color: $purple-color;
    color: $purple-color;
    background: $purple-background;
}

.orange_tag,
.code_tag {
    border-color: $orange-color;
    color: $orange-color;
    background: $orange-background;
}    

.green_tag,
.paper_tag,
.pencil_tag {
    border-color: $green-color;
    color: $green-color;
    background: $green-background;
}    

.blue_tag,
.topic_tag {
    border-color: $blue-color;
    color: $blue-color;
    background: $blue-background;
}    

.red_tag,
.exam_tag {
    border-color: $red-color;
    color: $red-color;
    background: $red-background;
}

.yellow_tag {
    border-color: $yellow-color;
    color: $yellow-color;
    backround: $yellow-background;
}
.gray_tag, .grey_tag {
    border-color: $grey-color-dark;
    color: $grey-color-dark;
    background: $grey-color-light;
}
    

.prompt_line {
    font-weight: bold;
}

.reading {
    font-size: smaller;
    font-style: italic;
    color: $grey-color-dark;
}

.site_sym {
    font-weight: bold;
    color: white;
}
.site_sym_inner, .site_icon {
    background: $site-color;
    border-radius: 0.2em;
    border: 1px solid $site-color;
    display: inline;
    padding: .15em;
}
.site_icon {
    height: 1em;
    margin-right: 0.2em;
}
.site_sym, .site_icon {
    vertical-align: -0.32em;
}
.navicon {
    height: 1em;
    vertical-align: -0.1em;
}

@supports (-moz-appearance:none) {
    .site_sym { padding-top: .1em; } 
}

.site_color {
    color: $site-color;
}

.footnotes {
    margin-top: 2em;
    border-top: 1px solid $grey-color;
    padding: 1em;
    font-size: smaller;
}
.footnotes:before {
    content: "Footnotes:";
}

ol.alpha,
ol.letter,
ol.alpha_marker,
ol.letter_marker {
    list-style-type: lower-alpha;
}

ol.roman,
ol.roman_marker {
    list-style-type: lower-roman;
}

figure {
    text-align: center;
    background: white;
    border: 1px solid #ccc;
    display: inline-block;
}
figure > * {
    padding: 10px;
}
figcaption {
    /* margin-top: 10px; */
    border-top: 1px solid #ccc;
    background: #eee;
}

.left {
    float: left;
    margin: 0 20px 20px 0;
}
.right {
    float: right;
    margin: 0 0 20px 20px;
}
.center {
    text-align: center;
}

.box {
    border-wdith: 1px;
    border-style: solid;
    border-width: 1px 1px 1px 1em;
    padding: 0 1em;
}

.alert_box, .rawalert_box {
    /* margin-left: auto;
    margin-right: auto; */
    margin-top: 1.5em;
    margin-bottom: 1.5em;
    clear: both;
}
.aside_box, .rawaside_box {
    clear: both;
    margin-top: 0.5em;
    margin-bottom: 0.5em;
}
@media (min-width: $width-narrow + 1) {
    .aside_box, .rawaside_box {
        width: 40%;
        float: right;
        margin-left: $spacing-unit;
    }
}
.alert_box, .rawalert_box {
    border-color: $orange-color;
    background-color: $orange-background;
}
.aside_box, .rawaside_box {
    border-color: $brand-color;
    background-color: $brand-color-light;
}

.box > * {
    font-weight: normal;
}
.box > *:last-child {
    margin-bottom: 1em;
}

.box_heading, .warning {
    font-size: 1.25em;
    font-weight: bold;
    margin: 0.8em 0;
}

/*
.warning:before {
    content: "!!!";
    background: $site-color;
    color: white;
    padding: 0.4em 0.8em;
    margin-right: 0.8em;
    display: inline-block;
}
*/

td {
    padding: 0 0.5em;
    border: 1px solid lighten($grey-color, 40%);
}
th {
    color: white;
    background: $grey-color-dark;
}
th a {
    color: lighten($brand-color, 30%);
    text-decoration: underline;

    &:visited {
        color: lighten($brand-color, 25%);
        text-decoration: underline;
    }

    &:hover {
        color: lighten($brand-color, 40%);
        text-decoration: underline;
    }
}

/* Heading numbers

body {
    counter-reset: h2counter;
    counter-reset: h1counter;
}
h1:before {
    content: counter(h1counter) ". ";
    counter-increment: h1counter;
    counter-reset: h2counter;
}
h2:before {
    content: counter(h1counter) "." counter(h2counter) ". ";
    counter-increment: h2counter;
}
.post-title:before, .no_toc:before, .nocount:before {
    content: none;
    counter-increment: none;
}

*/

#markdown-toc {
    .helplink {
        display: none;
    }
}

hr {
    margin: 2em 0;
    padding: 1px;
    border: none;
    background: $text-color;
}

.hidden {
    display: none;
}


.deletion {
    background: #aaa;
    text-decoration: line-through;
}
.addition {
    background: #ff8;
    font-weight: normal;
}
div.addition {
    padding: 0 1em;
    margin-left: -1em;
    margin-right: -1em;
}
.headline {
    font-weight: bold;
}

.spotlight {
    font-weight: bold;
}

.tt {
    font-family: monospace;
}
